<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task33.20 user list</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<body>
    <div class = "container">
        <div class = "text-center">
            <h2>Danh sách người dùng đăng ký</h2>
        </div>
        <div class = "row form-group">
            <button class = "btn btn-success" id="btn-add-user">Thêm user</button>
        </div>        
        <table class = "table table-border table-striped table-hover" id="table-users">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function(){
        onPageLoading();
        //gán sự kiện cho nút sửa
        $("#table-users").on("click",".btn-edit",onBtnEditClick);
        //gán sự kiện cho nút xóa
        $("#table-users").on("click",".btn-delete",onBtnDeleteClick);
    });
    $("#btn-add-user").click(function(){
        onBtnAddClick();
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading(){
        callApiGetDataUser();       
    };
    function onBtnEditClick(paramButton){
      console.log("Nút sửa được ấn, id của user tương ứng là: " + $(this).data("id"));
      const vDETAIL_FORM_URL = "updateUser.html";
      var vUrlToOpenPage = vDETAIL_FORM_URL + "?" + "id=" + $(this).data("id");
      window.location.href = vUrlToOpenPage;
    }
    function onBtnDeleteClick(paramButton){
        var vId = $(this).data("id");
      console.log("Nút xóa được ấn, id của user tương ứng là: " + vId);
      var vConfirmDelete = confirm("Bạn muốn xóa user id " +  vId + "?"); 
      if (vConfirmDelete){
        console.log("Xác nhận xóa user có id " +  vId);
        callAjaxApiDeleteUser(vId);
      } 
      else {
        console.log("Bạn đã cancel!");
      }    
    }
    function onBtnAddClick(){
        "use strict";
        const vINSERT_FORM_URL = "insertUser.html";
        var vUrlToOpenPage = vINSERT_FORM_URL;
        window.location.href = vUrlToOpenPage;
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm load data user
    function callApiGetDataUser(){
        "use strict";
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/",
            type: "GET",
            dataType: "json",
            success: function (paramRes){
                console.log(paramRes);
                loadDataToUserTable(paramRes);
            },
            error: function (ajaxContext){
                console.log(ajaxContext.responseText)
            }
        });
    }
    //hàm load dữ liệu vào user data table
    function loadDataToUserTable(paramUsers){
      var vUserTable = $("#table-users");
      for (var bI =0; bI <paramUsers.length; bI++){
        //thêm dòng mới và gắn vào table
        var bNewRow = $("<tr>").appendTo(vUserTable);
        //thêm các ô, gắn vào dòng trên và điền dữ liệu innerHTML cho từng ô
        $("<td>", {html: paramUsers[bI].id}).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].firstname}).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].lastname}).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].country}).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].subject}).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].customerType}).appendTo(bNewRow);
        $("<td>", {html: paramUsers[bI].registerStatus}).appendTo(bNewRow);
        //ô action
        var bActionCell = $("<td>").appendTo(bNewRow);
        //tạo nút sửa
        var bEditButton = $("<button>", {
          html: "Sửa",
          class: "btn btn-primary col-6 btn-edit"
        }).data("id", paramUsers[bI].id)
        .data("firstname", paramUsers[bI].firstname)
        .data("lastname", paramUsers[bI].lastname)
        .data("country", paramUsers[bI].country)
        .data("subject", paramUsers[bI].subject)
        .data("customerType", paramUsers[bI].customerType)
        .data("registerStatus", paramUsers[bI].registerStatus)
        .appendTo(bActionCell); //thêm vào ô action
        //tạo nút xóa
        var bDeleteButton = $("<button>", {
          html: "Xóa",
          class: "btn btn-danger col-6 btn-delete"
        }).data("id", paramUsers[bI].id)
        .data("firstname", paramUsers[bI].firstname)
        .data("lastname", paramUsers[bI].lastname)
        .data("country", paramUsers[bI].country)
        .data("subject", paramUsers[bI].subject)
        .data("customerType", paramUsers[bI].customerType)
        .data("registerStatus", paramUsers[bI].registerStatus)
        .appendTo(bActionCell);//thêm vào ô action
      }
    }
    //hàm gọi API xóa user
    function callAjaxApiDeleteUser(paramUserId){
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/" + paramUserId,
            type: "DELETE",            
            success: deleteUserSuccess,
            error: deleteUserError,
        });
    }
    //xử lý response success
    function deleteUserSuccess(paramResponse){
        alert("User is deleted succesfully!");
        //tải lại trang
        location.reload();
        console.log("%cDELETE USER: ", "color:orange");
        console.log(paramResponse);
    }
    //xử lý response error
    function deleteUserError(paramAjaxContext){
        alert(paramAjaxContext.responseText)
    }
</script>
</html>